import { decl, scope } from "./scope.js";
export const ifThen = (test, truthy, falsey) => ({
    tag: "if",
    type: "void",
    test,
    t: scope(truthy),
    f: falsey ? scope(falsey) : undefined,
});
export const ternary = (test, t, f) => ({
    tag: "ternary",
    type: t.type,
    test,
    t,
    f,
});
export function forLoop(...xs) {
    const [init, test, iter, body] = xs.length === 2
        ? [, xs[0], , xs[1]]
        : xs.length === 3
            ? [xs[0], xs[1], , xs[2]]
            : xs;
    return {
        tag: "for",
        type: "void",
        init: init ? decl(init) : undefined,
        test: test(init),
        iter: iter ? iter(init) : undefined,
        scope: scope(body(init)),
    };
}
export const whileLoop = (test, body) => ({
    tag: "while",
    type: "void",
    test,
    scope: scope(body),
});
const ctrl = (id) => ({
    tag: "ctrl",
    type: "void",
    id,
});
export const brk = ctrl("break");
export const cont = ctrl("continue");
export const discard = ctrl("discard");
